#include "addcurve.h"
#include "ui_addcurve.h"
#include "model/Mediator.h"

addCurve::addCurve(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::addCurve)
{
    ui->setupUi(this);
}

addCurve::~addCurve()
{
    delete ui;
}
//Resposta ao clique no botão para adicionar o ponto que formará a curva
void addCurve::on_btn_addPoint_clicked()
{
    int rc = ui->PontosCurva->rowCount();
    ui->PontosCurva->setRowCount(rc + 1);
}

void addCurve::on_btn_removePoint_clicked()
{
    int r = ui->PontosCurva->currentRow();
    ui->PontosCurva->removeRow(r);
}

void addCurve::on_addButtonBox_2_accepted()
{
    QList<double> xs, ys;
    int rc = ui->PontosCurva->rowCount();
    for(int i = 0; i < rc; i++) {
            QTableWidgetItem *x = ui->PontosCurva->item(i,0), *y = ui->PontosCurva->item(i,1);
            if((x != NULL) && (y != NULL)){
                xs << x->text().toInt();
                ys << y->text().toInt();
            }
    }
    if(!(xs.empty())&&!(ys.empty()))
    {
        if(ui->rbt_bezier->isChecked())
            Mediator::instance()->addBezier(xs,ys,ui->CurvaNome->text());
        else if (ui->rbt_spline->isChecked())
            Mediator::instance()->addBspline(xs,ys,ui->CurvaNome->text());
    }
    close();
}

void addCurve::on_addButtonBox_2_rejected()
{
    close();
}
