#include "model/Mediator.h"
#include "janelaprincipal.h"
#include "addpoint.h"
#include "addline.h"
#include "addcurve.h"
#include "addpolygon.h"
#include "transform.h"
#include <QDebug>
#include <QMessageBox>
#include <qfiledialog.h>


using namespace std;

//metodo construtor
JanelaPrincipal::JanelaPrincipal(QWidget *parent)
    : QMainWindow(parent)
{
	ui.setupUi(this);

}

//metodo destrutor
JanelaPrincipal::~JanelaPrincipal()
{
}

//Resposta ao clique na barra de menu na opção objeto ponto
void JanelaPrincipal::on_actionPonto_activated() {
	AddPoint addPointDialog;
	addPointDialog.exec();
}

//Resposta ao clique na barra de menu na opção objeto Linha
void JanelaPrincipal::on_actionLinha_activated() {
	AddLine addLineDialog;
	addLineDialog.exec();
}

//Resposta ao clique na barra de menu na opção objeto Poligono
void JanelaPrincipal::on_actionPoligono_activated() {
	AddPolygon addPolygonDialog;
	addPolygonDialog.exec();
}

//Resposta ao clique no botão de navegação up
void JanelaPrincipal::on_upButton_clicked() {
        Mediator::instance()->verticalMove(ui.spb_Des->value());
}

//Resposta ao clique no botão de navegação down
void JanelaPrincipal::on_downButton_clicked() {
        Mediator::instance()->verticalMove(-ui.spb_Des->value());
}

//Resposta ao clique no botão de navegação left
void JanelaPrincipal::on_leftButton_clicked() {
        Mediator::instance()->horizontalMove(-ui.spb_Des->value());
}

//Resposta ao clique no botão de navegação right
void JanelaPrincipal::on_rightButton_clicked() {
        Mediator::instance()->horizontalMove(ui.spb_Des->value());
}

//Metodo que retorna a janela principal
QGraphicsView* JanelaPrincipal::getCanvas() {
	return ui.canvas;
}

//Método responsável pela janela que mostra os itens
void JanelaPrincipal::setListModel(QStringListModel *listModel) {
	ui.objectList->setModel(listModel);
}

//Resposta ao clique no botão de zoomIn
void JanelaPrincipal::on_zoomInButton_clicked() {
        Mediator::instance()->zoomIn(ui.spb_Zoom->value());
}

//Resposta ao clique no botão de zoomOut
void JanelaPrincipal::on_zoomOutButton_clicked() {
        Mediator::instance()->zoomOut(ui.spb_Zoom->value());
}

//abre a janela de transformações se há um item selecionado
void JanelaPrincipal::on_actionTransformar_activated()
{
    if( Mediator::instance()->getSelectedItem() != NULL)
    {
    Transform *transformDialog = new Transform(this);
    transformDialog->exec();
    }
    else
        QMessageBox::warning(this,"Erro","Selecione um item da lista",QMessageBox::Ok);
}

//seleciona o objeto a ser transformado
void JanelaPrincipal::on_objectList_clicked(QModelIndex index)
{
       Mediator::instance()->setSelectedItem(Mediator::instance()->getShapes().value(index.row()));
}

//metodos de rotação
void JanelaPrincipal::on_RotacionarE_clicked()
{
     Mediator::instance()->rotate(-ui.AngRot->value());
}

void JanelaPrincipal::on_RotacionarD_clicked()
{
    Mediator::instance()->rotate(ui.AngRot->value());
}

void JanelaPrincipal::on_actionCurve_activated()
{
        addCurve addCDialog;
        addCDialog.exec();
}


void JanelaPrincipal::on_actionImportar_activated()
{
    QString fileName;
    QFileDialog* fd = new QFileDialog( this, "Abrir arquivo");
    fd->setFilter( "XML (*.xml)" );
    if ( fd->exec() == QDialog::Accepted )
        fileName = fd->selectedFiles().takeFirst();

    Mediator::instance()->loadFile(fileName);
}

void JanelaPrincipal::on_actionFechar_activated()
{
    exit(0);
}

void JanelaPrincipal::on_actionSalvar_activated()
{
    QString fileName = QFileDialog::getSaveFileName(this,  tr("Salvar arquivo"),  tr("*.xml") );
    Mediator::instance()->saveFile(fileName);
}

void JanelaPrincipal::on_actionImportar_triggered()
{

}
