#ifndef DISPLAYFILE_H_
#define DISPLAYFILE_H_

#include <QObject>
#include <QList>
#include <QStringListModel>
#include <QStringList>
#include "Shape.h"

/**
 * \brief Display File é um objeto que representa a lista de figuras a serem desenhados na tela.
 */
class DisplayFile: public QObject {
Q_OBJECT
public:
	DisplayFile();
        //metodo que retorna o modelo de representação da lista
	QStringListModel* getStringListModel();
        // Obtém uma lista de figuras presentes no DisplayFile
	QList<Shape*> getShapes();
        // Adiciona uma figura ao DisplayFile, e por conseqüência, atualiza na viewport
	void addShape(Shape*);

	virtual ~DisplayFile();
signals:
        // Sinal emitido quando uma figura é adicionada ao DisplayFile
	void shapeAdded();
private:
	QList<Shape*> shapeList;
	QStringListModel *stringListModel;
	QStringList *stringList;
};

#endif /* DISPLAYFILE_H_ */
