#include "ShapeFactory.h"
#include "Mediator.h"

//metodo construtor
ShapeFactory::ShapeFactory() {
}

//metodo destrutor
ShapeFactory::~ShapeFactory() {

}
//metodo que retorna a unica instacia mantendo o objeto como um singleton
ShapeFactory* ShapeFactory::instance() {
	static ShapeFactory uniqueInstance;
	return &uniqueInstance;
}

//metodo que cria o ponto
Point* ShapeFactory::createPoint(double x, double y, QString id)
{
	Point *p = new Point(x,y);
	p->setName(id);
        p->calcCpp(Mediator::instance()->getWindow()->getAngle());
	return p;
}

//metodo que cria a linha
Line* ShapeFactory::createLine(double x1, double y1, double x2, double y2, QString id) {
	Line *l = new Line(Point(x1,y1), Point(x2,y2));
	l->setName(id);
        l->calcCpp(Mediator::instance()->getWindow()->getAngle());
	return l;
}

//metodo que cria o poligono
Polygon* ShapeFactory::createPolygon(QList<double> xs, QList<double> ys, QString id, bool preenchido) {
	Polygon *pol = new Polygon();
	int numPoints = xs.size();
	for(int i = 0; i < numPoints; i++)
		pol->addPoint(Point(xs[i],ys[i]));
	pol->setName(id);
        pol->setFill(preenchido);
        pol->calcCpp(Mediator::instance()->getWindow()->getAngle());
	return pol;
}

//metodo que cria a curva de bezier
Bezier* ShapeFactory::createBezier(QList<double> xs, QList<double> ys, QString id) {
        Bezier *bez = new Bezier();
        int numPoints = xs.size();
        for(int i = 0; i < numPoints; i++)
                bez->addRPoint(Point(xs[i],ys[i]));
        bez->setName(id);
        bez->calcCpp(Mediator::instance()->getWindow()->getAngle());
        return bez;
}

Bspline* ShapeFactory::createBspline(QList<double> xs, QList<double> ys, QString id) {
        Bspline *bez = new Bspline();
        int numPoints = xs.size();
        for(int i = 0; i < numPoints; i++)
                bez->addRPoint(Point(xs[i],ys[i]));
        bez->setName(id);
        bez->calcCpp(Mediator::instance()->getWindow()->getAngle());
        return bez;
}
