#ifndef TRANSFORMER_H
#define TRANSFORMER_H

#include <math.h>
#include "model/Shape.h"
#include "model/Point.h"
#include "model/Line.h"
#include "model/Polygon.h"
#include "model/Bezier.h"
#include "bspline.h"
#include "Mediator.h"

class Transformer
{
public:
    Transformer();
    ~Transformer();
    //Metodo que realiza a rotação sobre a origem
    static void rotationOrigin(Shape* , int );
   //Metodo que realiza a rotação sobre o centro do objeto
    static void rotationCenter(Shape* , int );
   //Metodo que realiza a rotação sobre um ponto escolhido
    static void rotationPointasRef(Shape* , int , int ,int );
    //Metodo que realiza a translação do objeto
    static void translation(Shape*, int, int);
    //Metodo que realiza o escalonamento do objeto
    static void scale(Shape*,double,double);
    //Metodo que realiza os calculos da rotação
    static QList<Point> rotation(QList<Point>, Point media, int angle);


    static void MatMultMat42(double [4][4], double [4][2], double [4][2]);
private:
   //Metodo que realiza os calculos de escalonamento
    static QList<Point> Scale(QList<Point> pontos,Point media, double scaleX, double scaleY);
    //Metodo que realiza a multiplicação de um vetor por uma matriz 3x3
    static void multiVetMatriz33(double[3][3], double[3], double[3]);
    //Metodo que realiza a multiplicação de matrizes 3x3
    static void MatMultMat33(double [3][3], double [3][3], double [3][3]);

    //Metodo que calcula a media dos pontos informados
    static Point Media(QList<Point> pontos);
};

#endif // TRANSFORMER_H
