#ifndef VIEWPORT_H
#define VIEWPORT_H

#include <QGraphicsScene>
#include <QGraphicsView>
#include "Point.h"
#include "Line.h"
#include "Polygon.h"
#include "Bezier.h"
#include "bspline.h"

class ViewPort
{
public:
    ViewPort();
    ViewPort(double, QGraphicsView*);

    void addLine(Line* l, QPen pen);
    void addPolygon(Polygon*, QPen,bool);
    void addPoint(Point* p, QPen pen) ;
    void addBezier(Bezier*, QPen);
    void addBspline(Bspline*, QPen);
    void updateSceneCanvas();
    bool clipTesteLine(double[4],double[4],  double*, double*);
    void redrawing(double wxminm,double wyminm,double wxmaxm,double wymaxm);
    bool addLinee(Line* l, double pontos [4]);
    Point transform(Point p);
    double min(double a, double b);
    double max(double a, double b);

    bool isInside(Point*);


    virtual ~ViewPort();
private:
    QGraphicsScene *scene;
    QGraphicsView *canvas;
    double mySize;
    double viewPortSize;
    double rectSize;
    double wxmin, wymin;
    double wxmax, wymax;

};

#endif // VIEWPORT_H
