#include "xmlloader.h"
#include "Mediator.h"
#include <QDebug>
#include <sstream>

XMLLoader::XMLLoader()
{

}

XMLLoader::~XMLLoader()
{

}

Point XMLLoader::constructPoint(TiXmlElement& pElem){
        Point p;
        double valor;
        pElem.QueryDoubleAttribute("x", &valor);
        p.setX(valor);
        pElem.QueryDoubleAttribute("y", &valor);
        p.setY(valor);
        return p;

}

void XMLLoader::constructOnePoint(TiXmlHandle hElem)
{
    TiXmlElement* pElem = hElem.Element();
    double x,y;
    pElem->QueryDoubleAttribute("x", &x);
    pElem->QueryDoubleAttribute("y", &y);
    const char* cor  = pElem->Attribute("cor");
    if(cor == NULL){
        Mediator::instance()->addPoint(x,y,pElem->Attribute("nome"));
    }
    else
    {
        std::stringstream ss;
        int R,G,B;
        char p[2];
        p[0] = cor[0];
        p[1] = cor[1];
        p[2] = 0;
        ss << std::hex << p;
        ss >> R;
        ss.clear();
        p[0] = cor[2];
        p[1] = cor[3];
        ss << std::hex << p;
        ss >> G;
        ss.clear();
        p[0] = cor[4];
        p[1] = cor[5];
        ss << std::hex << p;
        ss >> B;
        Mediator::instance()->addPoint(x,y,pElem->Attribute("nome"),R,G,B);
    }
}

void XMLLoader::constructReta(TiXmlHandle hElem){
        TiXmlElement* pElem = hElem.FirstChildElement("ponto").Element();
        Point p1,p2;
        p1 = constructPoint(*pElem);
        pElem = pElem->NextSiblingElement("ponto");
        p2 = constructPoint(*pElem);
        pElem = hElem.Element();
        const char* cor  = pElem->Attribute("cor");
        if(cor == NULL){
            Mediator::instance()->addLine(p1.getX(),p1.getY(),p2.getX(),p2.getY(),pElem->Attribute("nome"));
        }
        else
        {
            std::stringstream ss;
            int R,G,B;
            char p[2];
            p[0] = cor[0];
            p[1] = cor[1];
            p[2] = 0;
            ss << std::hex << p;
            ss >> R;
            ss.clear();
            p[0] = cor[2];
            p[1] = cor[3];
            ss << std::hex << p;
            ss >> G;
            ss.clear();
            p[0] = cor[4];
            p[1] = cor[5];
            ss << std::hex << p;
            ss >> B;
            Mediator::instance()->addLine(p1.getX(),p1.getY(),p2.getX(),p2.getY(),pElem->Attribute("nome"),R,G,B);
        }
}

void XMLLoader::constructPoligono(TiXmlHandle hElem){
        QList <Point> pontos;
        for(TiXmlElement* pElem = hElem.FirstChild( "ponto" ).Element() ; pElem; pElem=pElem->NextSiblingElement("ponto")){
                pontos.append(constructPoint(*pElem));
        }
        QList <double> px;
        QList<double> py;
        for(int i =0 ; i<pontos.length(); i++)
        {
            px.append(pontos.at(i).getX());
            py.append(pontos.at(i).getY());
        }
        TiXmlElement* pElem = hElem.Element();

        const char* cor  = pElem->Attribute("cor");
        if(cor== NULL){
            if(strcmp(pElem->Attribute("cheio"),"verdadeiro") == 0 )
                Mediator::instance()->addPolygon(px,py,pElem->Attribute("nome"),true);
            else
                Mediator::instance()->addPolygon(px,py,pElem->Attribute("nome"),false);
        }
        else
        {
            std::stringstream ss;
            int R,G,B;
            char p[2];
            p[0] = cor[0];
            p[1] = cor[1];
            p[2] = 0;
            ss << std::hex << p;
            ss >> R;
            ss.clear();
            p[0] = cor[2];
            p[1] = cor[3];
            ss << std::hex << p;
            ss >> G;
            ss.clear();
            p[0] = cor[4];
            p[1] = cor[5];
            ss << std::hex << p;
            ss >> B;
            if(strcmp(pElem->Attribute("cheio"),"verdadeiro") == 0 )
                Mediator::instance()->addPolygon(px,py,pElem->Attribute("nome"),true,R,G,B);
            else
                Mediator::instance()->addPolygon(px,py,pElem->Attribute("nome"),false,R,G,B);
        }
}

void XMLLoader::constructSpline(TiXmlHandle hElem){
        QList <Point> pontos;
        for(TiXmlElement* pElem = hElem.FirstChild( "ponto" ).Element() ; pElem; pElem=pElem->NextSiblingElement("ponto")){
                pontos.append(constructPoint(*pElem));
        }
        QList <double> px;
        QList<double> py;
        for(int i =0 ; i<pontos.length(); i++)
        {
            px.append(pontos.at(i).getX());
            py.append(pontos.at(i).getY());
        }
        TiXmlElement* pElem = hElem.Element();
        const char* cor  = pElem->Attribute("cor");
        if(cor== NULL){
            Mediator::instance()->addBspline(px,py,pElem->Attribute("nome"));
        }
        else
        {
            std::stringstream ss;
            int R,G,B;
            char p[2];
            p[0] = cor[0];
            p[1] = cor[1];
            p[2] = 0;
            ss << std::hex << p;
            ss >> R;
            ss.clear();
            p[0] = cor[2];
            p[1] = cor[3];
            ss << std::hex << p;
            ss >> G;
            ss.clear();
            p[0] = cor[4];
            p[1] = cor[5];
            ss << std::hex << p;
            ss >> B;
            Mediator::instance()->addBspline(px,py,pElem->Attribute("nome"),R,G,B);
        }
}

void XMLLoader::constructBez(const char * nome, TiXmlHandle hElem,const char* cor){
      QList <Point> pontos;
      for(int i = 1; i<=4; i++){
            char *p =(char*) malloc(2*sizeof(char));
            p[0]= 'p';
            sprintf(&p[1],"%d",i);
          for(TiXmlElement* pElem = hElem.FirstChild(p).Element() ; pElem; pElem=pElem->NextSiblingElement("ponto")){
                    pontos.append(constructPoint(*pElem));
            }
        }
        QList <double> px;
        QList<double> py;
        for(int i =0 ; i<pontos.length(); i++)
        {
            px.append(pontos.at(i).getX());
            py.append(pontos.at(i).getY());
        }

        if(cor== NULL){
            Mediator::instance()->addBezier(px,py,nome);
        }
        else
        {
            std::stringstream ss;
            int R,G,B;
            char p[2];
            p[0] = cor[0];
            p[1] = cor[1];
            p[2] = 0;
            ss << std::hex << p;
            ss >> R;
            ss.clear();
            p[0] = cor[2];
            p[1] = cor[3];
            ss << std::hex << p;
            ss >> G;
            ss.clear();
            p[0] = cor[4];
            p[1] = cor[5];
            ss << std::hex << p;
            ss >> B;
            Mediator::instance()->addBezier(px,py,nome,R,G,B);
        }
}

void XMLLoader::shapesAtLevel(TiXmlHandle handle){
        TiXmlElement *pElem, *pElem2;

        pElem=handle.FirstChild( "ponto" ).Element();
        if (pElem){
            for( ; pElem; pElem=pElem->NextSiblingElement("ponto")){
                        constructOnePoint(pElem);
                }
        }

        pElem=handle.FirstChild( "reta" ).Element();
        if (pElem){
                for( ; pElem; pElem=pElem->NextSiblingElement("reta")){
                        constructReta(pElem) ;
                }
        }
        pElem=handle.FirstChild( "curvaBezier" ).Element();
        if (pElem){
            for( ; pElem; pElem=pElem->NextSiblingElement("curvaBezier")){
                        pElem2 = pElem->FirstChildElement("geometria");
                        for( ; pElem2; pElem2=pElem2->NextSiblingElement("geometria")) {
                            const char *cor = pElem->Attribute("cor");
                            if(cor== NULL)
                                constructBez(pElem->Attribute("nome"),pElem2,NULL);
                            else
                                constructBez(pElem->Attribute("nome"),pElem2,cor);
                    }
                }
        }

        pElem=handle.FirstChild( "curvaBSpline" ).Element();
        if (pElem){
            for( ; pElem; pElem=pElem->NextSiblingElement("curvaBSpline")){
                    constructSpline(pElem);
                }
        }

        pElem=handle.FirstChild( "poligono" ).Element();
        if (pElem){
            for( ; pElem; pElem=pElem->NextSiblingElement("poligono")){
                constructPoligono(pElem);
            }
        }

        pElem=handle.FirstChild( "formas" ).Element();
        if (pElem){
                shapesAtLevel(pElem);
        }
}
void XMLLoader::processShapes(TiXmlDocument& doc){
        TiXmlHandle hDoc(&doc);
        shapesAtLevel(hDoc);
}



//const char * getIndent( unsigned int numIndents )
//{
//        static const char * pINDENT="                                      + ";
//        static const unsigned int LENGTH=strlen( pINDENT );
//        unsigned int n=numIndents*NUM_INDENTS_PER_SPACE;
//        if ( n > LENGTH ) n = LENGTH;

//        return &pINDENT[ LENGTH-n ];
//}

//// same as getIndent but no "+" at the end
//const char * getIndentAlt( unsigned int numIndents )
//{
//        static const char * pINDENT="                                        ";
//        static const unsigned int LENGTH=strlen( pINDENT );
//        unsigned int n=numIndents*NUM_INDENTS_PER_SPACE;
//        if ( n > LENGTH ) n = LENGTH;

//        return &pINDENT[ LENGTH-n ];
//}

//int dump_attribs_to_stdout(TiXmlElement* pElement, unsigned int indent)
//{
//        if ( !pElement ) return 0;

//        TiXmlAttribute* pAttrib=pElement->FirstAttribute();
//        int i=0;
//        int ival;
//        double dval;
//        const char* pIndent=getIndent(indent);
//        printf("\n");
//        while (pAttrib)
//        {
//                printf( "%s%s: value=[%s]", pIndent, pAttrib->Name(), pAttrib->Value());

//                if (pAttrib->QueryIntValue(&ival)==TIXML_SUCCESS)    printf( " int=%d", ival);
//                if (pAttrib->QueryDoubleValue(&dval)==TIXML_SUCCESS) printf( " d=%1.1f", dval);
//                printf( "\n" );
//                i++;
//                pAttrib=pAttrib->Next();
//        }
//        return i;
//}

//void dump_to_stdout( TiXmlNode* pParent, unsigned int indent)
//{
//        if ( !pParent ) return;

//        TiXmlNode* pChild;
//        TiXmlText* pText;
//        int t = pParent->Type();
//        printf( "%s", getIndent(indent));
//        int num;

//        switch ( t )
//        {
//        case TiXmlNode::TINYXML_DOCUMENT:
//                printf( "Document" );
//                break;

//        case TiXmlNode::TINYXML_ELEMENT:
//                printf( "Element [%s]", pParent->Value() );
//                num=dump_attribs_to_stdout(pParent->ToElement(), indent+1);
//                switch(num)
//                {
//                        case 0:  printf( " (No attributes)"); break;
//                        case 1:  printf( "%s1 attribute", getIndentAlt(indent)); break;
//                        default: printf( "%s%d attributes", getIndentAlt(indent), num); break;
//                }
//                break;

//        case TiXmlNode::TINYXML_COMMENT:
//                printf( "Comment: [%s]", pParent->Value());
//                break;

//        case TiXmlNode::TINYXML_UNKNOWN:
//                printf( "Unknown" );
//                break;

//        case TiXmlNode::TINYXML_TEXT:
//                pText = pParent->ToText();
//                printf( "Text: [%s]", pText->Value() );
//                break;

//        case TiXmlNode::TINYXML_DECLARATION:
//                printf( "Declaration" );
//                break;
//        default:
//                break;
//        }
//        printf( "\n" );
//        for ( pChild = pParent->FirstChild(); pChild != 0; pChild = pChild->NextSibling())
//        {
//                dump_to_stdout( pChild, indent+1 );
//        }
//}

//// load the named file and dump its structure to STDOUT
//void dump_to_stdout(const char* pFilename)
//{
//        TiXmlDocument doc(pFilename);
//        bool loadOkay = doc.LoadFile();
//        if (loadOkay)
//        {
//                printf("\n%s:\n", pFilename);
//                dump_to_stdout( &doc ); // defined later in the tutorial
//        }
//        else
//        {
//                printf("Failed to load file \"%s\"\n", pFilename);
//        }
//}
